package proyecto.com;

import java.text.Format;
import java.util.Calendar;
import java.util.GregorianCalendar;
 
import android.app.Activity;
import android.content.ContentResolver;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.CalendarContract;
import android.provider.CalendarContract.Calendars;
import android.provider.CalendarContract.Events;
import android.text.format.DateFormat;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
 
public class CalendarActivity  extends Activity implements OnClickListener{ 
      
    public static final String[] EVENT_PROJECTION = new String[] { 
            Calendars._ID, // 0 
            Calendars.ACCOUNT_NAME, // 1 
            Calendars.CALENDAR_DISPLAY_NAME // 2 
    }; 
   
     
    private static final int PROJECTION_DISPLAY_NAME_INDEX = 2;
    
    private Cursor mCursor = null;
	private static final String[] COLS = new String[] { CalendarContract.Events.TITLE, CalendarContract.Events.DTSTART};
	
   
    @Override 
    public void onCreate(Bundle savedInstanceState) { 
        super.onCreate(savedInstanceState); 
        setContentView(R.layout.main); 
        
        
        long comienzo = 0;
        Calendar begin = Calendar.getInstance();
        begin.set(2012, 9, 01);
        
        comienzo = begin.getTimeInMillis();
        
        
        //mCursor = getContentResolver().query(CalendarContract.Events.CONTENT_URI, COLS, null, null, CalendarContract.Events.DTSTART+" ASC");
        mCursor = getContentResolver().query(CalendarContract.Events.CONTENT_URI, COLS, 
        		CalendarContract.Events.DTSTART + " >=" + comienzo, null, CalendarContract.Events.DTSTART+" ASC");
        mCursor.moveToFirst();
        Button b = (Button)findViewById(R.id.next);
        b.setOnClickListener(this);
        b = (Button)findViewById(R.id.previous);
        b.setOnClickListener(this);
        onClick(findViewById(R.id.previous));
        
    } 
    
    
    @Override
	public void onClick(View v) {
		//TextView tv = (TextView)findViewById(R.id.data);
		TextView tv2 = (TextView)findViewById(R.id.data2);
		TextView tv3 = (TextView)findViewById(R.id.data3);
		TextView tv4 = (TextView)findViewById(R.id.data4);
		String title = "N/A";
		Long start = 0L;
	    switch(v.getId()) {
		case R.id.next:
			if(!mCursor.isLast()) mCursor.moveToNext();
			break;
		case R.id.previous:
			if(!mCursor.isFirst()) mCursor.moveToPrevious();
			break;
		}
		Format df = DateFormat.getDateFormat(this);
		Format tf = DateFormat.getTimeFormat(this);
        try {
        	title = mCursor.getString(0);
        	start = mCursor.getLong(1);
        } catch (Exception e) {
        	//ignore
        }
        //tv.setText(title+" el "+df.format(start)+" a las "+tf.format(start));
        //tv2.setText("Da: "+df.format(start)+"//Hora: "+tf.format(start)+". Asunto: "+title);
        tv2.setText("DA: "+df.format(start));
        tv3.setText("HORA: "+tf.format(start));
        tv4.setText("ASUNTO: "+title);
	}
    
   
    public void onClick2(View view) { 
  
        Intent intent = new Intent(Intent.ACTION_INSERT); 
        intent.setType("vnd.android.cursor.item/event"); 
        intent.putExtra(Events.TITLE, "Introduce da/hora cita"); 
        intent.putExtra(Events.EVENT_LOCATION, "Introduce lugar"); 
        intent.putExtra(Events.DESCRIPTION, "Introduce datos paciente"); 
   
        GregorianCalendar calDate = new GregorianCalendar(2012, 10, 07); 
        intent.putExtra(CalendarContract.EXTRA_EVENT_BEGIN_TIME, 
                calDate.getTimeInMillis()); 
        intent.putExtra(CalendarContract.EXTRA_EVENT_END_TIME, 
                calDate.getTimeInMillis()); 
   
        intent.putExtra(CalendarContract.EXTRA_EVENT_ALL_DAY, false); 
   
        //Para crear eventos con recurrencia
        /*intent.putExtra(Events.RRULE, 
                "FREQ=WEEKLY;COUNT=11;WKST=SU;BYDAY=TU,TH");*/ 
   
        intent.putExtra(Events.ACCESS_LEVEL, Events.ACCESS_PRIVATE); 
        intent.putExtra(Events.AVAILABILITY, Events.AVAILABILITY_BUSY); 
   
        startActivity(intent); 
   
    } 
   
    public void queryCalendar(View view) { 
        Cursor cur = null; 
        ContentResolver cr = getContentResolver(); 
        Uri uri = Calendars.CONTENT_URI; 
        String selection = "((" + Calendars.ACCOUNT_NAME + " = ?) AND (" 
                + Calendars.ACCOUNT_TYPE + " = ?))"; 
   
        /*String[] selectionArgs = new String[] { "aconesa@gmail.com", 
                "com.google" };*/
        
        String[] selectionArgs = new String[] {"aconesa@gmail.com"};
        
        cur = cr.query(uri, EVENT_PROJECTION, selection, selectionArgs, null); 
   
        while (cur.moveToNext()) { 
            String displayName = null; 
            displayName = cur.getString(PROJECTION_DISPLAY_NAME_INDEX); 
            Toast.makeText(this, "Calendar " + displayName, Toast.LENGTH_SHORT) 
                    .show(); 
        } 
    } 
}
