package com.example.dentaldroid;

import java.util.HashMap;
import java.util.LinkedList;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ListView;
import android.widget.SimpleAdapter;

public class LectorDeFeeds extends Activity implements OnClickListener{
    /** Called when the activity is first created. */
	
	Button enviar;
	
	//Variables necesarias para el parser de XML
	static final String DATA_TITLE = "T";
	static final String DATA_LINK  = "L";
	
	static LinkedList<HashMap<String, String>> data;
	
	//https://twitter.com/statuses/user_timeline/116752712.rss
	//http://webdental.wordpress.com/feed/
	//http://www.odontologiaactual.com/feed/
	//http://elmundo.feedsportal.com/elmundo/rss/portada.xml
	//static String feedUrl = "http://www.odontologiaactual.com/feed/";
	//static String feedUrl = "http://elmundo.feedsportal.com/elmundo/rss/portada.xml";
	static String feedUrl = "http://webdental.wordpress.com/feed/";
	
	//QUEREMOS QUE EL AVISO SE MUESTRE Y COMO TAREA DE FONDO SE CARGUEN LOS DATOS. NECESITAMOS UN HILO DE EJECUCIN.
	private ProgressDialog progressDialog;
	
	private final Handler progressHandler = new Handler(){
		
		@SuppressWarnings("unchecked")
		public void handleMessage(Message msg){
			if(msg.obj != null){
				data = (LinkedList<HashMap<String, String>>) msg.obj;
				setData(data);
			}
			progressDialog.dismiss();
		}
	};

	
	
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.lectorfeeds);
        
        setTitle("Colegio Oficial de Dentistas de Sevilla");
        
        enviar = (Button) findViewById(R.id.botonEnviar);
        enviar.setOnClickListener((OnClickListener)this);
        
    }
	
	@Override
	public void onClick(View v) {
		// TODO LECTOR arreglar
		//if(v.equals(enviar)){
		if(v.getId() == R.id.botonEnviar){
			ListView lv = (ListView) findViewById(R.id.listaData);
			if(lv.getAdapter() != null){
				AlertDialog.Builder builder = new AlertDialog.Builder(LectorDeFeeds.this);
				builder.setTitle("Actualizar")
				.setMessage("Est seguro de querer volver a cargar los datos?")
				.setCancelable(false)
				.setPositiveButton("S", new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						loadData();
					}
				})
				.setNegativeButton("No", new DialogInterface.OnClickListener() {
					
					@Override
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						dialog.cancel();
					}
				}).create().show();
			}else{
				loadData();
			}
		}
	}
	
	//FUNCIN AUXILIAR QUE RECIBE LA LISTA DE MAPAS Y NOS PERMITE CREAR UN ADAPTADOR PARA POBLAR AL LISTVIEW DEL DISEO.
	private void setData(LinkedList<HashMap<String, String>> data){
		SimpleAdapter sAdapter = new SimpleAdapter(getApplicationContext(), data, android.R.layout.two_line_list_item, 
								new String[] {DATA_TITLE, DATA_LINK}, new int[] {android.R.id.text1, android.R.id.text2});
		ListView lv = (ListView) findViewById(R.id.listaData);
		lv.setAdapter(sAdapter);
	}
	
	//FUNCIN AUXILIAR QUE INICIA LA CARGA DE DATOS, MUESTRA AL USUARIO UN DILOGO DE LA CARGA Y LEVANTA UN HILO CON LA EJECUCIN.
	private void loadData(){
		progressDialog = ProgressDialog.show(LectorDeFeeds.this, "", 
							"Por favor, espere mientras se cargan los datos...", true);
		
		new Thread(new Runnable() {
			
			@Override
			//FUNCIONALIDAD DEL HILO DE EJECUCIN
			public void run() {
				// TODO Auto-generated method stub
				XMLParser parser = new XMLParser(feedUrl);
				Message msg = progressHandler.obtainMessage();
				msg.obj = parser.parse();
				progressHandler.sendMessage(msg);
			}
		}).start();
	}
	
}