package com.example.dentaldroid;

import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.DatePickerDialog.OnDateSetListener;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

public class LibroDeCuentasVs2Activity extends Activity implements OnItemSelectedListener, OnClickListener{
    
	public static String fechaActual;
	public EditText fecha;
	public Button cambiarfecha;
	public Button mostrarTratam;
	public Button cambiarHoy;
	public int ano;
	public int mes;
	public int dia;
	
	static final int DATE_DIALOG_ID = 0;
	
	//----------------------------------
	public static Spinner spinner;
	//----------------------------------
	

	public DatePickerDialog.OnDateSetListener mDateSetListener = new OnDateSetListener(){
    	public void onDateSet(DatePicker view, int day, int month, int year){
    		final Calendar c = Calendar.getInstance();
    		
    		dia = year;
    		mes = month;
    		ano = day;
                        
            updateDisplay();
    	}
    };
	
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.tab1cuentas);
        
        spinner = (Spinner) findViewById(R.id.spinner);
        
        ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this, 
        		R.array.porcentajes_array, android.R.layout.simple_list_item_checked);
        adapter.setDropDownViewResource(android.R.layout.simple_list_item_checked);
        spinner.setAdapter(adapter);
        
        spinner.setOnItemSelectedListener(this);
        
        //Capturamos la fecha actual.
        /*fechaActual = java.text.DateFormat.getDateInstance().format(new Date());
        fecha = (EditText) findViewById(R.id.cadenaFecha);
        fecha.setText(fechaActual);*/
        
        
        fecha = (EditText) findViewById(R.id.cadenaFecha);
        cambiarfecha = (Button) findViewById(R.id.botoncambiofecha);
        cambiarfecha.setOnClickListener(this);
        
        //obtenemos la fecha actual
        final Calendar c = Calendar.getInstance();
        ano = c.get(Calendar.YEAR);
        dia = c.get(Calendar.DAY_OF_MONTH);
        mes = c.get(Calendar.MONTH);
        //mostramos la fecha
        updateDisplay();
        
        
        mostrarTratam = (Button) findViewById(R.id.botontratamientos);
        mostrarTratam.setOnClickListener(this);
        
        cambiarHoy = (Button) findViewById(R.id.botoncambioHoy);
        cambiarHoy.setOnClickListener(this);
        
    }

	@Override
	public void onItemSelected(AdapterView<?> parent, View view, int pos,
			long id) {
		
		Toast.makeText(parent.getContext(), parent.getItemAtPosition(pos).toString(), Toast.LENGTH_LONG).show();
		
	}

	@Override
	public void onNothingSelected(AdapterView<?> arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onClick(View v) {
		
		switch (v.getId()) {
			case R.id.botoncambiofecha:
				showDialog(DATE_DIALOG_ID);
				break;
	
			case R.id.botoncambioHoy:
				String fechahoy = DateFormat.getDateInstance().format(new Date());
				fecha.setText(fechahoy);
				break;
			
			case R.id.botontratamientos:
				
				Intent i = new Intent(this, ListaTratamiento.class);
				i.putExtra("fecha", fecha.getText().toString());
				startActivity(i);
				break;
				
			default:
				break;
			}
		
	}
	
	public Dialog onCreateDialog(int id){
		switch(id){
			case DATE_DIALOG_ID:
				return new DatePickerDialog(this, 
						mDateSetListener, dia, mes, ano);
		}
		
		return null;
	}
	
	public void updateDisplay(){
		fecha.setText(new StringBuilder().append(dia).append("/").append(mes+1).append("/").append(ano));
	}
}