package com.example.dentaldroid;

import java.util.ArrayList;
import java.util.List;

public class RegistroSingleton {

	private String nombre = null;
	private String email = null;
	private String fecha = null;
	private String asunto = null;
	
	private List<String> nombres = new ArrayList<String>();
	private List<String> emails = new ArrayList<String>();
	private List<String> fechas = new ArrayList<String>();
	private List<String> asuntos = new ArrayList<String>();
	
	private static RegistroSingleton INSTANCE = null;
	
	private RegistroSingleton(){}
	
	private synchronized static void createInstance(){
		if(INSTANCE == null){
			INSTANCE = new RegistroSingleton();
		}
	}
	
	public static RegistroSingleton getInstance(){
		if(INSTANCE == null){
			createInstance();
		}
		
		return INSTANCE;
	}
	
	public String getNombre(){
		return this.nombre;
	}
	
	public void setNombre(String nombre){
		this.nombre = nombre;
	}
	
	public String getEmail(){
		return this.email;
	}
	
	public void setEmail(String email){
		this.email = email;
	}
	
	public String getFecha(){
		return this.fecha;
	}
	
	public void setFecha(String fecha){
		this.fecha = fecha;
	}
	
	public String getAsunto(){
		return this.asunto;
	}
	
	public void setAsunto(String asunto){
		this.asunto = asunto;
	}

	public void aadeNombre(String nombre) {
		this.nombres.add(nombre);
	}

	public List<String> getNombres() {
		return nombres;
	}

	public void aadeEmail(String email) {
		this.emails.add(email);
	}

	public List<String> getEmails() {
		return emails;
	}

	public void aadeFecha(String fecha) {
		this.fechas.add(fecha);
	}

	public List<String> getFechas() {
		return fechas;
	}
	
	public void aadeAsunto(String asunto){
		this.asuntos.add(asunto);
	}
	
	public List<String> getAsuntos(){
		return asuntos;
	}
}
