package com.example.dentaldroid;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.LinkedList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class XMLParser {
	private URL url;
	
	public XMLParser(String url) {
		try {
			this.url = new URL(url);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
	}
	
	public LinkedList<HashMap<String, String>> parse() {
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		LinkedList<HashMap<String, String>> entries = new LinkedList<HashMap<String, String>>();
		HashMap<String, String> entry;
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document dom = builder.parse(this.url.openConnection().getInputStream());
			Element root = dom.getDocumentElement();
			NodeList items = root.getElementsByTagName("item");
			for (int i=0;i<items.getLength();i++){
				entry = new HashMap<String, String>();				
				Node item = items.item(i);
				NodeList properties = item.getChildNodes();
				for (int j=0;j<properties.getLength();j++){
					Node property = properties.item(j);
					String name = property.getNodeName();
					if (name.equalsIgnoreCase("title")){
						entry.put(LectorDeFeeds.DATA_TITLE, property.getFirstChild().getNodeValue());
					} else if (name.equalsIgnoreCase("description")){
						//entry.put(LectorDeFeeds.DATA_LINK, property.getFirstChild().getNodeValue());
						
						String descrip = property.getFirstChild().getNodeValue();
						if(descrip.indexOf("<img") != -1){
							descrip = descrip.substring(0, descrip.indexOf("<img"));
						}
						entry.put(LectorDeFeeds.DATA_LINK, descrip);
						
					}
				}
				entries.add(entry);
			}
		} catch (Exception e) {
			throw new RuntimeException(e);
		} 

		return entries;
	}
	
	private String sanear_string(String titulo){
		
		titulo = titulo.replaceAll("", "a");
		titulo = titulo.replaceAll("", "e");
		titulo = titulo.replaceAll("", "i");
		titulo = titulo.replaceAll("", "o");
		titulo = titulo.replaceAll("", "u");
		
		return titulo;
	}
	
	private static String sanear_string2(String input) {
	    // Cadena de caracteres original a sustituir.
	    String original = "u";
	    // Cadena de caracteres ASCII que reemplazarn los originales.
	    String ascii = "aaaeeeiiiooouuunAAAEEEIIIOOOUUUNcC";
	    String output = input;
	    for (int i=0; i<original.length(); i++) {
	        // Reemplazamos los caracteres especiales.
	        output = output.replace(original.charAt(i), ascii.charAt(i));
	    }//for i
	    return output;
	}
}